/*************************************************************************
 *
 *  $RCSfile: sc_invmerge.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:31:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

#include <vcl/window.hxx>
// auto strip #include <tools/debug.hxx>

#include "invmerge.hxx"
namespace binfilter {

//------------------------------------------------------------------

/*N*/ ScInvertMerger::ScInvertMerger( Window* pWindow ) :
/*N*/ 	pWin( pWindow )
/*N*/ {
/*N*/ 	//	both rectangles empty
/*N*/ }

/*N*/ ScInvertMerger::~ScInvertMerger()
/*N*/ {
/*N*/ 	Flush();
/*N*/ }

/*N*/ void ScInvertMerger::Flush()
/*N*/ {
/*N*/ 	FlushLine();
/*N*/ 	FlushTotal();
/*N*/ 
/*N*/ 	DBG_ASSERT( aLineRect.IsEmpty() && aTotalRect.IsEmpty(), "Flush: not empty" );
/*N*/ }

/*N*/ void ScInvertMerger::FlushTotal()
/*N*/ {
/*N*/ 	if( aTotalRect.IsEmpty() )
/*N*/ 		return;							// nothing to do
/*N*/ 
/*?*/ 	pWin->Invert( aTotalRect, INVERT_HIGHLIGHT );
/*?*/ 	aTotalRect.SetEmpty();
/*N*/ }

/*N*/ void ScInvertMerger::FlushLine()
/*N*/ {
/*N*/ 	if( aLineRect.IsEmpty() )
/*N*/ 		return;							// nothing to do
/*N*/ 
/*?*/ 	if ( aTotalRect.IsEmpty() )
/*?*/ 	{
/*?*/ 		aTotalRect = aLineRect;			// start new total rect
/*?*/ 	}
/*?*/ 	else
/*?*/ 	{
/*?*/ 		if ( aLineRect.Left()  == aTotalRect.Left()  &&
/*?*/ 			 aLineRect.Right() == aTotalRect.Right() &&
/*?*/ 			 aLineRect.Top()   == aTotalRect.Bottom() + 1 )
/*?*/ 		{
/*?*/ 			// extend total rect
/*?*/ 			aTotalRect.Bottom() = aLineRect.Bottom();
/*?*/ 		}
/*?*/ 		else
/*?*/ 		{
/*?*/ 			FlushTotal();					// draw old total rect
/*?*/ 			aTotalRect = aLineRect;			// and start new one
/*?*/ 		}
/*?*/ 	}
/*?*/ 
/*?*/ 	aLineRect.SetEmpty();
/*N*/ }

//STRIP001 void ScInvertMerger::AddRect( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	if ( aLineRect.IsEmpty() )
//STRIP001 	{
//STRIP001 		aLineRect = rRect;			// start new line rect
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( rRect.Top()    == aLineRect.Top()    &&
//STRIP001 			 rRect.Bottom() == aLineRect.Bottom() &&
//STRIP001 			 rRect.Left()   == aLineRect.Right() + 1 )
//STRIP001 		{
//STRIP001 			// extend line rect
//STRIP001 			aLineRect.Right() = rRect.Right();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			FlushLine();			// use old line rect for total rect
//STRIP001 			aLineRect = rRect;		// and start new one
//STRIP001 		}
//STRIP001 	}
//STRIP001 }




}
