 /*************************************************************************
 *
 *  $RCSfile: sfx2_sfxhelp.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:30:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "sfxhelp.hxx"

#include <algorithm>

#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif
#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_XTOPWINDOW_HPP_
#include <com/sun/star/awt/XTopWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAMESSUPPLIER_HPP_
#include <com/sun/star/frame/XFramesSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCH_HPP_
#include <com/sun/star/frame/XDispatch.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDISPATCHPROVIDER_HPP_
#include <com/sun/star/frame/XDispatchProvider.hpp>
#endif
#include <com/sun/star/frame/FrameSearchFlag.hpp>
#include <toolkit/helper/vclunohelper.hxx>

#ifndef _UTL_CONFIGMGR_HXX_
#include <unotools/configmgr.hxx>
#endif
#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif

#ifndef INCLUDED_SVTOOLS_HELPOPT_HXX
#include <svtools/helpopt.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_MODULEOPTIONS_HXX
#include <svtools/moduleoptions.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _UTL_CONFIGMGR_HXX_
#include <unotools/configmgr.hxx>
#endif
#ifndef _UCBHELPER_CONTENT_HXX
#include <ucbhelper/content.hxx>
#endif

#include <svtools/pathoptions.hxx>
#include <rtl/ustring.hxx>
#include <osl/process.h>

#define _SVSTDARR_STRINGSDTOR
#define _SVSTDARR_ULONGSSORT
#include <svtools/svstdarr.hxx>

#include "sfxsids.hrc"
#include "app.hxx"
#include "viewfrm.hxx"
#include "msgpool.hxx"
#include "newhelp.hxx"
#include "objsh.hxx"
#include "docfac.hxx"
#include "sfxresid.hxx"
#include "helper.hxx"
#include "app.hrc"

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif

#ifndef _SFX_SFXUNO_HXX
#include <bf_sfx2/sfxuno.hxx>
#endif

#ifndef _WINDOW_HXX
#include <vcl/window.hxx>
#endif

namespace binfilter {

using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::util;

#define ERROR_TAG	String( DEFINE_CONST_UNICODE("Error: ") )
#define PATH_TAG	String( DEFINE_CONST_UNICODE("\nPath: ") )

// -----------------------------------------------------------------------

#define STARTERLIST 0

/*N*/ void AppendConfigToken_Impl( String& rURL, sal_Bool bQuestionMark )
/*N*/ {
/*N*/ 	// this completes a help url with the system parameters "Language" and "System"
/*N*/ 	// detect installed locale
/*N*/ 	Any aLocale =
/*N*/ 		::utl::ConfigManager::GetConfigManager()->GetDirectConfigProperty( ::utl::ConfigManager::LOCALE );
/*N*/     ::rtl::OUString aLocaleStr;
/*N*/ 	if ( !( aLocale >>= aLocaleStr ) )
/*N*/ 		// fallback is english
/*?*/ 		aLocaleStr = ::rtl::OUString( DEFINE_CONST_UNICODE("en") );
/*N*/ 
/*N*/ 	// query part exists?
/*N*/ 	if ( bQuestionMark )
/*N*/ 		// no, so start with '?'
/*N*/ 		rURL += '?';
/*N*/ 	else
/*N*/ 		// yes, so only append with '&'
/*?*/ 		rURL += '&';
/*N*/ 
/*N*/ 	// set parameters
/*N*/ 	rURL += DEFINE_CONST_UNICODE("Language=");
/*N*/ 	rURL += String( aLocaleStr );
/*N*/ 	rURL += DEFINE_CONST_UNICODE("&System=");
/*N*/ 	rURL += SvtHelpOptions().GetSystem();
/*N*/ }

// -----------------------------------------------------------------------

/*N*/ sal_Bool GetHelpAnchor_Impl( const String& _rURL, String& _rAnchor )
/*N*/ {
/*N*/ 	sal_Bool bRet = sal_False;
/*N*/ 	::rtl::OUString sAnchor;
/*N*/ 
/*N*/ 	try
/*N*/ 	{
/*N*/ 		::ucb::Content aCnt( INetURLObject( _rURL ).GetMainURL( INetURLObject::NO_DECODE ),
/*N*/ 							 Reference< ::com::sun::star::ucb::XCommandEnvironment > () );
/*N*/ 		if ( ( aCnt.getPropertyValue( ::rtl::OUString::createFromAscii( "AnchorName" ) ) >>= sAnchor ) )
/*N*/ 		{
/*N*/ 
/*N*/ 			if ( sAnchor.getLength() > 0 )
/*N*/ 			{
/*N*/ 				_rAnchor = String( sAnchor );
/*N*/ 				bRet = sal_True;
/*N*/ 			}
/*N*/ 		}
/*N*/ 		else
/*N*/ 		{
/*N*/ 			DBG_ERRORFILE( "Property 'AnchorName' is missing" );
/*N*/ 		}
/*N*/ 	}
/*N*/ 	catch( ::com::sun::star::uno::Exception& )
/*N*/ 	{
/*N*/ 	}
/*N*/ 
/*N*/ 	return bRet;
/*N*/ }

// -----------------------------------------------------------------------

class SfxHelpOptions_Impl : public ::utl::ConfigItem
{
private:
    SvULongsSort*   m_pIds;

public:
                    SfxHelpOptions_Impl();
                    ~SfxHelpOptions_Impl();

    BOOL            HasId( ULONG nId ) { USHORT nDummy; return m_pIds ? m_pIds->Seek_Entry( nId, &nDummy ) : FALSE; }
};

/*N*/ static Sequence< ::rtl::OUString > GetPropertyNames()
/*N*/ {
/*N*/ 	static const char* aPropNames[] =
/*N*/ 	{
/*N*/         "HelpAgentStarterList",
/*N*/ 	};
/*N*/ 
/*N*/     const int nCount = sizeof( aPropNames ) / sizeof( const char* );
/*N*/ 	Sequence< ::rtl::OUString > aNames( nCount );
/*N*/ 	::rtl::OUString* pNames = aNames.getArray();
/*N*/ 	::rtl::OUString* pEnd	= pNames + aNames.getLength();
/*N*/ 	int i = 0;
/*N*/ 	for ( ; pNames != pEnd; ++pNames )
/*N*/ 		*pNames = ::rtl::OUString::createFromAscii( aPropNames[i++] );
/*N*/ 
/*N*/ 	return aNames;
/*N*/ }

// -----------------------------------------------------------------------

/*N*/ SfxHelpOptions_Impl::SfxHelpOptions_Impl()
/*N*/     : ConfigItem( ::rtl::OUString::createFromAscii("Office.SFX/Help") )
/*N*/     , m_pIds( NULL )
/*N*/ {
/*N*/ 	Sequence< ::rtl::OUString > aNames = GetPropertyNames();
/*N*/ 	Sequence< Any > aValues = GetProperties( aNames );
/*N*/ 	EnableNotification( aNames );
/*N*/ 	const Any* pValues = aValues.getConstArray();
/*N*/ 	DBG_ASSERT( aValues.getLength() == aNames.getLength(), "GetProperties failed" );
/*N*/ 	if ( aValues.getLength() == aNames.getLength() )
/*N*/ 	{
/*N*/ 		for ( int nProp = 0; nProp < aNames.getLength(); nProp++ )
/*N*/ 		{
/*N*/ 			DBG_ASSERT( pValues[nProp].hasValue(), "property value missing" );
/*N*/ 			if ( pValues[nProp].hasValue() )
/*N*/ 			{
/*N*/ 				switch ( nProp )
/*N*/ 				{
/*N*/                     case STARTERLIST :
/*N*/                     {
/*N*/                         ::rtl::OUString aCodedList;
/*N*/                         if ( pValues[nProp] >>= aCodedList )
/*N*/                         {
/*N*/                             String aTmp( aCodedList );
/*N*/                             USHORT nCount = aTmp.GetTokenCount( ',' );
/*N*/                             m_pIds = new SvULongsSort();
/*N*/                             for ( USHORT n=0; n<nCount; n++ )
/*N*/                                 m_pIds->Insert( (ULONG) aTmp.GetToken( n, ',' ).ToInt64() );
/*N*/                         }
/*N*/                         else
/*N*/                             DBG_ERRORFILE( "Wrong property type!" );
/*N*/ 
/*N*/                         break;
/*N*/                     }
/*N*/ 
/*N*/ 					default:
/*N*/                         DBG_ERRORFILE( "Wrong property!" );
/*N*/                         break;
/*N*/ 				}
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ }

/*N*/ SfxHelpOptions_Impl::~SfxHelpOptions_Impl()
/*N*/ {
/*N*/     delete m_pIds;
/*N*/ }

// class SfxHelp_Impl ----------------------------------------------------

class SfxHelp_Impl
{
private:
	sal_Bool							m_bIsDebug;		// environment variable "help_debug=1"
    SfxHelpOptions_Impl*				m_pOpt;			// the options
	::std::vector< ::rtl::OUString >	m_aModulesList;	// list of all installed modules
	void					Load();

public:
    SfxHelp_Impl( sal_Bool bDebug );
    ~SfxHelp_Impl();

    SfxHelpOptions_Impl*	GetOptions();
	String					GetHelpText( ULONG nHelpId, const String& rModule );	// get "Active Help"
	sal_Bool				HasModule( const ::rtl::OUString& rModule );			// module installed
	sal_Bool				IsHelpInstalled();										// module list not empty
};

/*N*/ SfxHelp_Impl::SfxHelp_Impl( sal_Bool bDebug ) :
/*N*/ 
/*N*/ 	m_bIsDebug		( bDebug ),
/*N*/     m_pOpt      	( NULL )
/*N*/ 
/*N*/ {
}

SfxHelp_Impl::~SfxHelp_Impl()
{
    delete m_pOpt;
}

void SfxHelp_Impl::Load()
{
/*N*/ 	// fill modules list
/*N*/ 	// create the help url (empty, without module and helpid)
/*N*/ 	String sHelpURL( DEFINE_CONST_UNICODE("vnd.sun.star.help://") );
/*N*/ 	AppendConfigToken_Impl( sHelpURL, sal_True );
/*N*/ 	// open ucb content and get the list of the help modules
/*N*/ 	// the list contains strings with three tokens "ui title \t type \t url"
/*N*/ 	Sequence< ::rtl::OUString > aAllModulesList = SfxContentHelper::GetResultSet( sHelpURL );
/*N*/ 	sal_Int32 nLen = aAllModulesList.getLength();
/*N*/ 	m_aModulesList.reserve( nLen + 1 );
/*N*/ 	const ::rtl::OUString* pBegin = aAllModulesList.getConstArray();
/*N*/ 	const ::rtl::OUString* pEnd	= pBegin + nLen;
/*N*/ 	for ( ; pBegin != pEnd; ++pBegin )
/*N*/ 	{
/*N*/ 		// get one module string
/*N*/ 		String sModule( *pBegin );
/*N*/ 		// extract the url
/*N*/ 		String sURL = sModule.GetToken( 2, '\t' );
/*N*/ 		// insert the module (the host part of the "vnd.sun.star.help" url)
/*N*/ 		m_aModulesList.push_back( ::rtl::OUString( INetURLObject( sURL ).GetHost() ) );
/*N*/ 	}
/*N*/ }

/*N*/ String SfxHelp_Impl::GetHelpText( ULONG nHelpId, const String& rModule )
/*N*/ {
/*N*/ 	// create help url
/*N*/     String aHelpURL = SfxHelp::CreateHelpURL( nHelpId, rModule );
/*N*/ 	// added 'active' parameter
/*N*/ 	aHelpURL.Insert( String( DEFINE_CONST_UNICODE("&Active=true") ), aHelpURL.SearchBackward( '#' ) );
/*N*/ 	// load help string
/*N*/ 	return SfxContentHelper::GetActiveHelpString( aHelpURL );
/*N*/ }

/*N*/ SfxHelpOptions_Impl* SfxHelp_Impl::GetOptions()
/*N*/ {
/*N*/ 	// create if not exists
/*N*/     if ( !m_pOpt )
/*N*/         m_pOpt = new SfxHelpOptions_Impl;
/*N*/     return m_pOpt;
/*N*/ }

/*N*/ sal_Bool SfxHelp_Impl::HasModule( const ::rtl::OUString& rModule )
/*N*/ {
/*N*/ 	if ( !m_aModulesList.size() )
/*N*/ 		Load();
/*N*/ 	return ( ::std::find( m_aModulesList.begin(), m_aModulesList.end(), rModule ) != m_aModulesList.end() );
/*N*/ }

/*N*/ sal_Bool SfxHelp_Impl::IsHelpInstalled()
/*N*/ {
/*N*/ 	if ( !m_aModulesList.size() )
/*N*/ 		Load();
/*N*/ 	return ( m_aModulesList.begin() != m_aModulesList.end() );
/*N*/ }

// class SfxHelp ---------------------------------------------------------

/*N*/ SfxHelp::SfxHelp() :
/*N*/ 
/*N*/ 	bIsDebug( sal_False ),
/*N*/     pImp	( NULL )
/*N*/ 
/*N*/ {
/*N*/ 	// read the environment variable "HELP_DEBUG"
/*N*/ 	// if it's set, you will see debug output on active help
/*N*/ 	{
/*N*/ 		::rtl::OUString sHelpDebug;
/*N*/ 		::rtl::OUString sEnvVarName( RTL_CONSTASCII_USTRINGPARAM( "HELP_DEBUG" ) );
/*N*/ 		osl_getEnvironment( sEnvVarName.pData, &sHelpDebug.pData );
/*N*/ 		bIsDebug = ( 0 != sHelpDebug.getLength() );
/*N*/ 	}
/*N*/ 
/*N*/ 	pImp = new SfxHelp_Impl( bIsDebug );
/*N*/ 
/*N*/     Any aLocale =
/*N*/ 		::utl::ConfigManager::GetConfigManager()->GetDirectConfigProperty( ::utl::ConfigManager::LOCALE );
/*N*/     ::rtl::OUString aLocaleStr;
/*N*/     if ( !( aLocale >>= aLocaleStr ) )
/*?*/         aLocaleStr = ::rtl::OUString( DEFINE_CONST_UNICODE("en") );
/*N*/     sal_Int32 nSepPos = aLocaleStr.indexOf( '_' );
/*N*/     if ( nSepPos != -1 )
/*N*/     {
/*?*/         aLanguageStr = aLocaleStr.copy( 0, nSepPos );
/*?*/         aCountryStr = aLocaleStr.copy( nSepPos+1 );
/*N*/     }
/*N*/     else
/*N*/     {
/*N*/         nSepPos = aLocaleStr.indexOf( '-' );
/*N*/         if ( nSepPos != -1 )
/*N*/         {
/*N*/             aLanguageStr = aLocaleStr.copy( 0, nSepPos );
/*N*/             aCountryStr = aLocaleStr.copy( nSepPos+1 );
/*N*/         }
/*N*/         else
/*N*/         {
/*?*/             aLanguageStr = aLocaleStr;
/*N*/         }
/*N*/     }
/*N*/ }

/*N*/ SfxHelp::~SfxHelp()
/*N*/ {
/*N*/     delete pImp;
/*N*/ }

/*N*/ String GetFactoryName_Impl( const SfxViewFrame* pFrame )
/*N*/ {
/*N*/ 	// module name == short name of the factory (e.g. "swriter", "scalc",...)
/*N*/ 	String aName = String::CreateFromAscii( pFrame->GetObjectShell()->GetFactory().GetShortName() );
/*N*/ 	// cut sub factory, if exists (e.g. "swriter/web")
/*N*/ 	xub_StrLen nPos = aName.Search( '/' );
/*N*/ 	if ( nPos != STRING_NOTFOUND )
/*?*/ 		aName.Erase( nPos );
/*N*/ 	return aName;
/*N*/ }

/*N*/ String SfxHelp::GetHelpModuleName_Impl( ULONG nHelpId )
/*N*/ {
/*N*/     String aModuleName;
/*N*/     SfxViewFrame* pViewFrame = SfxViewFrame::Current();
/*N*/ 	if ( pViewFrame )
/*N*/ 	{
/*N*/ 	    SfxViewFrame* pParentViewFrame = pViewFrame->GetParentViewFrame_Impl();
/*N*/ 
/*N*/ 		// Wenn es ein Slot ist, kann es sein, da\s internes InPlace vorliegt
/*N*/ 		// und eine Container-SlotId gefragt ist
/*N*/ 		if ( nHelpId >= (ULONG) SID_SFX_START && nHelpId <= (ULONG) SHRT_MAX && pParentViewFrame )
/*N*/ 		{
/*N*/ 			// Ist es ein ContainerSlot ?
/*?*/             const SfxSlot* pSlot = SFX_APP()->GetSlotPool(pViewFrame).GetSlot( (USHORT) nHelpId );
/*?*/ 			if ( !pSlot || pSlot->IsMode( SFX_SLOT_CONTAINER ) )
/*?*/ 				pViewFrame = pParentViewFrame;
/*N*/ 		}
/*N*/ 
/*N*/ 		if ( pViewFrame->GetObjectShell() )
/*N*/ 		{
/*N*/             aModuleName = GetFactoryName_Impl( pViewFrame );
/*N*/ 			// help for module installed? If help isn't installed, module search will be disabled.
/*N*/ 			sal_Bool bHasModule = pImp->IsHelpInstalled() ? pImp->HasModule( aModuleName ) : sal_True;
/*N*/ 			// if not, search through the shell hierachy for an installed module
/*N*/ 			while ( !bHasModule && pParentViewFrame && pParentViewFrame->GetObjectShell() )
/*N*/ 			{
/*?*/ 	            aModuleName = GetFactoryName_Impl( pParentViewFrame );
/*?*/ 				bHasModule = pImp->HasModule( aModuleName );
/*?*/ 				pParentViewFrame = pParentViewFrame->GetParentViewFrame_Impl();
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ 
/*N*/ 	return aModuleName;
/*N*/ }

/*N*/ String SfxHelp::CreateHelpURL_Impl( ULONG nHelpId, const String& rModuleName )
/*N*/ {
/*N*/ 	String aModuleName( rModuleName );
/*N*/ 	if ( aModuleName.Len() == 0 )
/*N*/ 	{
/*N*/ 		// no active module (quicklaunch?) -> detect default module
/*N*/ 		SvtModuleOptions aModOpt;
/*N*/         if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SWRITER ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("swriter");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SCALC ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("scalc");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SIMPRESS ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("simpress");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SDRAW ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("sdraw");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SMATH ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("smath");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SCHART ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("schart");
/*?*/         else if ( aModOpt.IsModuleInstalled( SvtModuleOptions::E_SBASIC ) )
/*?*/ 			aModuleName = DEFINE_CONST_UNICODE("sbasic");
/*N*/ 		else
/*N*/ 		{
/*N*/ 			DBG_ERRORFILE( "no installed module found" );
/*N*/ 		}
/*N*/ 	}
/*N*/ 
/*N*/ 	// build up the help URL
/*N*/     String aHelpURL;
/*N*/     if ( aTicket.Len() )
/*N*/     {
/*N*/         // if there is a ticket, we are inside a plugin, so a special Help URL must be sent
/*?*/         aHelpURL = DEFINE_CONST_UNICODE("vnd.sun.star.cmd:help?");
/*?*/         aHelpURL += DEFINE_CONST_UNICODE("HELP_Request_Mode=contextIndex&HELP_Session_Mode=context&HELP_CallMode=portal&HELP_Device=html");
/*?*/ 
/*?*/         if ( !nHelpId )
/*?*/         {
/*?*/ 			// no help id -> start page
/*?*/             aHelpURL += DEFINE_CONST_UNICODE("&HELP_ContextID=start");
/*?*/         }
/*?*/         else
/*?*/         {
/*?*/             aHelpURL += DEFINE_CONST_UNICODE("&HELP_ContextID=");
/*?*/             aHelpURL += String::CreateFromInt64( nHelpId );
/*?*/         }
/*?*/ 
/*?*/         aHelpURL += DEFINE_CONST_UNICODE("&HELP_ProgramID=");
/*?*/         aHelpURL += aModuleName;
/*?*/         aHelpURL += DEFINE_CONST_UNICODE("&HELP_User=");
/*?*/         aHelpURL += aUser;
/*?*/         aHelpURL += DEFINE_CONST_UNICODE("&HELP_Ticket=");
/*?*/         aHelpURL += aTicket;
/*?*/         aHelpURL += DEFINE_CONST_UNICODE("&HELP_Language=");
/*?*/         aHelpURL += aLanguageStr;
/*?*/         if ( aCountryStr.Len() )
/*?*/         {
/*?*/             aHelpURL += DEFINE_CONST_UNICODE("&HELP_Country=");
/*?*/             aHelpURL += aCountryStr;
/*?*/         }
/*N*/     }
/*N*/     else
/*N*/     {
/*N*/ 		sal_Bool bHasAnchor = sal_False;
/*N*/ 		String aAnchor;
/*N*/         aHelpURL = String::CreateFromAscii("vnd.sun.star.help://");
/*N*/         aHelpURL += aModuleName;
/*N*/ 
/*N*/         if ( !nHelpId )
/*N*/             aHelpURL += String::CreateFromAscii("/start");
/*N*/         else
/*N*/         {
/*N*/             aHelpURL += '/';
/*N*/             aHelpURL += String::CreateFromInt64( nHelpId );
/*N*/ 
/*N*/ 			String aTempURL = aHelpURL;
/*N*/ 	        AppendConfigToken_Impl( aTempURL, sal_True );
/*N*/ 			bHasAnchor = GetHelpAnchor_Impl( aTempURL, aAnchor );
/*N*/ 		}
/*N*/ 
/*N*/         AppendConfigToken_Impl( aHelpURL, sal_True );
/*N*/ 
/*N*/ 		if ( bHasAnchor )
/*N*/ 		{
/*N*/ 			aHelpURL += '#';
/*N*/ 			aHelpURL += aAnchor;
/*N*/ 		}
/*N*/     }
/*N*/ 
/*N*/     return aHelpURL;
/*N*/ }

/*?*/ BOOL SfxHelp::Start( const String& rURL, const Window* pWindow )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); return FALSE;//STRIP001 
//STRIP001 	String aHelpURL( rURL );
//STRIP001 	INetURLObject aObj( aHelpURL );
//STRIP001 	::rtl::OUString sHelpKeyword;
//STRIP001 	if ( aObj.GetProtocol() != INET_PROT_VND_SUN_STAR_HELP )
//STRIP001 	{
//STRIP001 		aHelpURL = CreateHelpURL_Impl( 0, GetHelpModuleName_Impl( 0 ) );
//STRIP001 		sHelpKeyword = ::rtl::OUString( rURL );
//STRIP001 	}
//STRIP001     Reference < XDispatchProvider > xFrame;
//STRIP001     Reference < XFramesSupplier > xDesktop( ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance(
//STRIP001 		DEFINE_CONST_UNICODE("com.sun.star.frame.Desktop") ), UNO_QUERY );
//STRIP001     Reference < XFrame > xActiveTask = xDesktop->getActiveFrame();
//STRIP001 
//STRIP001 	Sequence < PropertyValue > aArgs;
//STRIP001 	if ( sHelpKeyword.getLength() > 0 )
//STRIP001 	{
//STRIP001 		aArgs.realloc( 1 );
//STRIP001     	aArgs[0].Name = String( DEFINE_CONST_UNICODE("HelpKeyword") );
//STRIP001     	aArgs[0].Value <<= sHelpKeyword;
//STRIP001 	}
//STRIP001     sal_Int32 nFlag = FrameSearchFlag::ALL;
//STRIP001 	sal_Bool bHelpTaskExists = sal_False;
//STRIP001     if ( aTicket.Len() )
//STRIP001     {
//STRIP001         xFrame = Reference < XDispatchProvider > ( xActiveTask, UNO_QUERY );
//STRIP001 		nFlag  = FrameSearchFlag::TASKS | FrameSearchFlag::CREATE;
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001 	    if ( xActiveTask.is() )
//STRIP001 		{
//STRIP001 			// try to find the help frame
//STRIP001 		    ::rtl::OUString aTarget = ::rtl::OUString( DEFINE_CONST_UNICODE("OFFICE_HELP") );
//STRIP001 		    xFrame = Reference < XDispatchProvider > (
//STRIP001 				xActiveTask->findFrame( aTarget, FrameSearchFlag::GLOBAL ), UNO_QUERY );
//STRIP001 		}
//STRIP001         // otherwise the URL can be dispatched to the help frame
//STRIP001         if ( !xFrame.is() )
//STRIP001         {
//STRIP001 		    Reference < XFrame > xFrameFinder( xDesktop, UNO_QUERY );
//STRIP001             Reference < XFrame > xTask = xFrameFinder->findFrame( DEFINE_CONST_UNICODE( "_blank" ), 0 );
//STRIP001 			xTask->setName( DEFINE_CONST_OUSTRING("OFFICE_HELP_TASK") );
//STRIP001             Window* pWin = VCLUnoHelper::GetWindow( xTask->getContainerWindow() );
//STRIP001             pWin->SetText( String( SfxResId( STR_HELP_WINDOW_TITLE ) ) );
//STRIP001             SfxHelpWindow_Impl* pHlpWin = new SfxHelpWindow_Impl( xTask, pWin, WB_DOCKBORDER );
//STRIP001             pHlpWin->Show();
//STRIP001             Reference< ::com::sun::star::awt::XWindow > xWindow = VCLUnoHelper::GetInterface( pHlpWin );
//STRIP001             xWindow->setPosSize( 50, 50, 300, 200, ::com::sun::star::awt::PosSize::SIZE );
//STRIP001             if ( !xTask->setComponent( xWindow, Reference < XController >() ) )
//STRIP001                 return FALSE;
//STRIP001             else
//STRIP001             {
//STRIP001                 pHlpWin->setContainerWindow( xTask->getContainerWindow() );
//STRIP001                 pHlpWin->SetHelpURL( aHelpURL );
//STRIP001 				xFrame = Reference < XDispatchProvider >( pHlpWin->getTextFrame(), UNO_QUERY );
//STRIP001                 xTask->getContainerWindow()->setVisible( sal_True );
//STRIP001             }
//STRIP001         }
//STRIP001 		else
//STRIP001 			bHelpTaskExists = sal_True;
//STRIP001 	}
//STRIP001 
//STRIP001     if ( xFrame.is() )
//STRIP001     {
//STRIP001         ::com::sun::star::util::URL aURL;
//STRIP001         aURL.Complete = aHelpURL;
//STRIP001         Reference < XURLTransformer > xTrans( ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance(
//STRIP001 			DEFINE_CONST_UNICODE("com.sun.star.util.URLTransformer" )), UNO_QUERY );
//STRIP001         xTrans->parseStrict( aURL );
//STRIP001         Reference < XDispatch > xDispatch =
//STRIP001 			xFrame->queryDispatch( aURL, DEFINE_CONST_UNICODE("OFFICE_HELP"), nFlag );
//STRIP001         if ( xDispatch.is() )
//STRIP001 			xDispatch->dispatch( aURL, aArgs );
//STRIP001 
//STRIP001 		if ( bHelpTaskExists )
//STRIP001 		{
//STRIP001 			// bring the help task to front
//STRIP001 		    Reference < XFrame > xFrameFinder( xDesktop, UNO_QUERY );
//STRIP001             Reference < XFrame > xTask = xFrameFinder->findFrame(
//STRIP001 				DEFINE_CONST_UNICODE("OFFICE_HELP_TASK"), FrameSearchFlag::TASKS );
//STRIP001 			if ( xTask.is() )
//STRIP001 			{
//STRIP001 				Reference < ::com::sun::star::awt::XTopWindow > xTopWin( xTask->getContainerWindow(), UNO_QUERY );
//STRIP001 				if ( xTopWin.is() )
//STRIP001 					xTopWin->toFront();
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001         return TRUE;
//STRIP001     }
//STRIP001     else
//STRIP001         return FALSE;
/*?*/ }

/*?*/ BOOL SfxHelp::Start( ULONG nHelpId, const Window* pWindow )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); return FALSE;//STRIP001 
//STRIP001     String aHelpModuleName( GetHelpModuleName_Impl( nHelpId ) );
//STRIP001     String aHelpURL = CreateHelpURL( nHelpId, aHelpModuleName );
//STRIP001 	if ( pWindow && SfxContentHelper::IsHelpErrorDocument( aHelpURL ) )
//STRIP001 	{
//STRIP001 		// no help found -> try with parent help id.
//STRIP001 		Window* pParent = pWindow->GetParent();
//STRIP001 		while ( pParent )
//STRIP001 		{
//STRIP001 			nHelpId = pParent->GetHelpId();
//STRIP001 		    aHelpURL = CreateHelpURL( nHelpId, aHelpModuleName );
//STRIP001 
//STRIP001 			if ( !SfxContentHelper::IsHelpErrorDocument( aHelpURL ) )
//STRIP001 				break;
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pParent = pParent->GetParent();
//STRIP001 				if ( !pParent )
//STRIP001 					// create help url of start page ( helpid == 0 -> start page)
//STRIP001 					aHelpURL = CreateHelpURL( 0, aHelpModuleName );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return Start( aHelpURL, pWindow );
/*?*/ }

/*N*/ XubString SfxHelp::GetHelpText( ULONG nHelpId, const Window* pWindow )
/*N*/ {
/*N*/ 	String aModuleName = GetHelpModuleName_Impl( nHelpId );
/*N*/     String aHelpText = pImp->GetHelpText( nHelpId, aModuleName );
/*N*/ 	ULONG nNewHelpId = 0;
/*N*/ 
/*N*/ 	if ( pWindow && aHelpText.Len() == 0 )
/*N*/ 	{
/*N*/ 		// no help text found -> try with parent help id.
/*N*/ 		Window* pParent = pWindow->GetParent();
/*N*/ 		while ( pParent )
/*N*/ 		{
/*N*/ 			nNewHelpId = pParent->GetHelpId();
/*N*/ 			aHelpText = pImp->GetHelpText( nNewHelpId, aModuleName );
/*N*/ 
/*N*/ 			if ( aHelpText.Len() > 0 )
/*?*/ 				pParent = NULL;
/*N*/ 			else
/*N*/ 				pParent = pParent->GetParent();
/*N*/ 		}
/*N*/ 
/*N*/ 		if ( bIsDebug && aHelpText.Len() == 0 )
/*?*/ 			nNewHelpId = 0;
/*N*/ 	}
/*N*/ 
/*N*/ 	if ( bIsDebug )
/*N*/ 	{
/*?*/ 		aHelpText += DEFINE_CONST_UNICODE("\n\n");
/*?*/ 		aHelpText += aModuleName;
/*?*/ 		aHelpText += DEFINE_CONST_UNICODE(" - ");
/*?*/ 		aHelpText += String::CreateFromInt64( nHelpId );
/*?*/ 		if ( nNewHelpId )
/*?*/ 		{
/*?*/ 			aHelpText += DEFINE_CONST_UNICODE(" - ");
/*?*/ 			aHelpText += String::CreateFromInt64( nNewHelpId );
/*N*/ 		}
/*N*/ 	}
/*N*/ 
/*N*/ 	return aHelpText;
/*N*/ }

/*N*/ String SfxHelp::CreateHelpURL( ULONG nHelpId, const String& rModuleName )
/*N*/ {
/*N*/ 	String aURL;
/*N*/ 	SfxHelp* pHelp = SAL_STATIC_CAST( SfxHelp*, Application::GetHelp() );
/*N*/ 	if ( pHelp )
/*N*/ 		aURL = pHelp->CreateHelpURL_Impl( nHelpId, rModuleName );
/*N*/ 	return aURL;
/*N*/ }

/*N*/ void SfxHelp::OpenHelpAgent( SfxFrame *pFrame, ULONG nHelpId )
/*N*/ {
/*N*/ 	if ( SvtHelpOptions().IsHelpAgentAutoStartMode() )
/*N*/ 	{
/*N*/ 		SfxHelp* pHelp = SAL_STATIC_CAST( SfxHelp*, Application::GetHelp() );
/*N*/ 		if ( pHelp )
/*N*/ 		{
/*N*/ 			SfxHelpOptions_Impl *pOpt = pHelp->pImp->GetOptions();
/*N*/     		if ( !pOpt->HasId( nHelpId ) )
/*N*/         		return;
/*N*/ 
/*N*/ 			try
/*N*/ 			{
/*?*/ 				URL aURL;
/*?*/         		aURL.Complete = pHelp->CreateHelpURL_Impl( nHelpId, pHelp->GetHelpModuleName_Impl( nHelpId ) );
/*?*/         		Reference < XURLTransformer > xTrans( ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance(
/*?*/ 					::rtl::OUString::createFromAscii("com.sun.star.util.URLTransformer" ) ), UNO_QUERY );
/*?*/         		xTrans->parseStrict(aURL);
/*?*/ 
/*?*/         		Reference< XDispatchProvider > xDispProv( pFrame->GetTopFrame()->GetFrameInterface(), UNO_QUERY );
/*?*/ 				Reference< XDispatch > xHelpDispatch;
/*?*/ 				if ( xDispProv.is() )
/*?*/ 					xHelpDispatch = xDispProv->queryDispatch(
/*?*/ 						aURL, ::rtl::OUString::createFromAscii("_helpagent"),
/*?*/ 						FrameSearchFlag::PARENT | FrameSearchFlag::SELF );
/*?*/ 
/*?*/         		DBG_ASSERT( xHelpDispatch.is(), "OpenHelpAgent: could not get a dispatcher!" );
/*?*/ 				if ( xHelpDispatch.is() )
/*?*/ 					xHelpDispatch->dispatch( aURL, Sequence< PropertyValue >() );
/*N*/ 			}
/*N*/ 			catch( const Exception& )
/*N*/ 			{
/*N*/         		DBG_ERRORFILE( "OpenHelpAgent: caught an exception while executing the dispatch!" );
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ }

}
