/*************************************************************************
 *
 *  $RCSfile: SchPersistentObjectPointer.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:25:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): Andre Fischer <andre.w.fischer@germany.sun.com>
 *
 *
 ************************************************************************/
 
#ifndef	_SCH_PERSISTENT_OBJECT_POINTER
#define	_SCH_PERSISTENT_OBJECT_POINTER

#ifndef _SOLAR_H
# include	<tools/solar.h>
#endif

#include	<vector>
namespace binfilter {

class	SdrObject;
class	ChartModel;


/**
	@descr	A persisten pointer lets you identify an SdrObject of the chart
		unambiguously.  Its main use is to rember the marked object before a
		BuildChart() is called and remark it afterwards.  This is done by
		storing an object's id and some additionall data.
	@todo	There is no invalid object id available.
*/
//STRIP001 class	SchPersistentObjectPointer
//STRIP001 {
//STRIP001 public:
//STRIP001 	/**	@desr Create a persistent object pointer for an CHOBJID_...
//STRIP001 			and optional indices to specify a data row or data point.
//STRIP001 		@param	nObjectId	This has to be a valid CHOBJID_...
//STRIP001 		@param	nSeries		Specifies a data row.
//STRIP001 		@param	nIndex		Specifies a data point in a data row.
//STRIP001 	*/
//STRIP001 	SchPersistentObjectPointer	(UINT16		nObjectId, 
//STRIP001 								long 		nSeries = -1,
//STRIP001 								long		nIndex = -1);
//STRIP001 	/** @descr Creates a persistent object pointer for the given object.
//STRIP001 		@param pObject Object that is represented by this class.
//STRIP001 	*/
//STRIP001 	SchPersistentObjectPointer	(const SdrObject * pObject);
//STRIP001 	~SchPersistentObjectPointer	(void);
//STRIP001 	
//STRIP001 	/**	@descr	Return the object id of the represented object.
//STRIP001 		@return	The object id of the represented object.  If that is invalid,
//STRIP001 			the return value is undefined, because there is no proper id for this.
//STRIP001 	*/
//STRIP001 	UINT16			GetObjectId	(void)	const;
//STRIP001 	
//STRIP001 	/**	@descr	Return the index of the data series or -1 if the represented 
//STRIP001 		object is neither a data row nor a data point.
//STRIP001 	*/
//STRIP001 	long			GetSeries	(void)	const;
//STRIP001 	
//STRIP001 	/**	@descr	Return the index of the data point inside its data series 
//STRIP001 		or -1 if the represented object is not a data point.
//STRIP001 	*/
//STRIP001 	long			GetIndex	(void)	const;
//STRIP001 	
//STRIP001 	/**	@descr	Return a list of pointers of the represented objects with respect to
//STRIP001 			the given model.  The returned value is list rather then a single pointer
//STRIP001 			because for instance a single data series may be represented by a set of
//STRIP001 			individual objects.
//STRIP001 		@param	pModel	The returned object belongs to this chart model.
//STRIP001 		@return	A possibly empty list of pointers to SdrObjects.  If between two
//STRIP001 			calls a BuildChart was carried out, the results will be different from
//STRIP001 			the pointer given to the constructor.
//STRIP001 	*/
//STRIP001 	const std::vector<SdrObject*>	&	GetPointers	(ChartModel * pModel);
//STRIP001 
//STRIP001 private:
//STRIP001 	UINT16	mnObjectId;		///	CHOBJID_... for the represented object.
//STRIP001 	long	mnSeries;		///	Index of the data row or -1 if not applicable.
//STRIP001 	long	mnIndex;		///	Index of the data point inside its row or -1.
//STRIP001 	std::vector<SdrObject*>
//STRIP001 			maObjectList;	///	List of represented objects.
//STRIP001 };

} //namespace binfilter
#endif
