/*************************************************************************
 *
 *  $RCSfile: fsetvwsh.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:29:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXFSETVIW_HXX
#define _SFXFSETVIW_HXX

#include <bf_sfx2/viewsh.hxx>
class SplitWindow;
namespace binfilter {

class SfxFrameSetDescriptor;
class SfxFrame;
class SfxURLFrame;
struct SfxFrameSet_Impl;

//===========================================================================
// Die SfxFrameSetViewShell ist die zur SfxFrameSetObjectShell geh"orende
// DefaultView. Sie erzeugt ein SfxFrameSet und benutzt dessen SplitWindow
// als EditWindow.
// "Uber die SfxFrameSetViewShell k"onnen alls Slots ausgef"uhrt werden, die
// die splitbare View betreffen.
//===========================================================================

class SfxFrameSetViewShell: public SfxViewShell
{
//STRIP001 friend class SfxFrameSetWindow_Impl;
	SfxFrameSetDescriptor*	pDescriptor;
	BOOL					bEditMode;
	SfxFrameSet_Impl*		pImp;

private:
//STRIP001 	void            Construct();
//STRIP001 	DECL_LINK(		EventHdl_Impl, void*);

protected:
	virtual void    OuterResizePixel( const Point &rOfs, const Size &rSize ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void    OuterResizePixel( const Point &rOfs, const Size &rSize );
	virtual void    InnerResizePixel( const Point &rOfs, const Size &rSize ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void    InnerResizePixel( const Point &rOfs, const Size &rSize );
	virtual void    SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
							const SfxHint& rHint, const TypeId& rHintType ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 const SfxHint& rHint, const TypeId& rHintType );
public:
					TYPEINFO();
					SfxFrameSetViewShell( SfxViewFrame *pFrame,
										  const SfxFrameSetViewShell& rWin,
										  USHORT nFlags = SFX_VIEW_MAXIMIZE_FIRST );
					SfxFrameSetViewShell( SfxViewFrame *pFrame,
										  SfxViewShell *pOld,
										  USHORT nFlags = SFX_VIEW_MAXIMIZE_FIRST );
					~SfxFrameSetViewShell();

//STRIP001 					SFX_DECL_INTERFACE( SFX_INTERFACE_SFXFRAMESETVIEWSH );
	virtual void    Activate( BOOL bMDI ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 virtual void    Activate( BOOL bMDI );
//STRIP001 	void			Fill( const SfxFrameSetDescriptor* pSet );
//STRIP001 	void			ReFill( const SfxFrameSetDescriptor* pSet );
//STRIP001 	void			MakeWindows( const SfxFrameSetDescriptor*,
//STRIP001 											SfxFrame*, USHORT );
//STRIP001 	SplitWindow*	GetSplitWindow() const;
//STRIP001 
//STRIP001 	BOOL			IsInEditMode() const
//STRIP001 					{ return bEditMode; }
//STRIP001 
//STRIP001 	void			SetEditMode( BOOL bSet )
//STRIP001 					{ bEditMode = bSet; }
//STRIP001 
//STRIP001 	void 			SetActiveFrame( SfxFrame* );
//STRIP001 	SfxFrame*		GetActiveFrame() const;
//STRIP001 
//STRIP001 	const SfxFrameSetDescriptor*
//STRIP001 					GetDescriptor() const
//STRIP001 					{ return pDescriptor; }
//STRIP001 
//STRIP001 	void 			UpdateFrameBorder( SfxFrameSetDescriptor* pSet=NULL );
//STRIP001 	long			GetDefaultSplitSize() const;
//STRIP001 
//STRIP001 	SfxFrameSetViewShell*
//STRIP001 					GetParentFrameSet() const;
//STRIP001 	void 			SaveUndo( SfxFrameSetDescriptor* pUndo,
//STRIP001 							SfxFrameSetDescriptor *pRedo, const String&, BOOL bClose = FALSE );
//STRIP001 
//STRIP001 	BOOL            StartEditing();
//STRIP001 	BOOL            EndEditing();
//STRIP001 	USHORT          GetItemId( SfxFrame* );
//STRIP001 	USHORT          GetCurItemId();
//STRIP001 	SfxFrame*   	Split( USHORT, USHORT );
//STRIP001 	void            SetFrameContent( USHORT, const String& );
//STRIP001 	void            SetFrameName( USHORT, const String& );
//STRIP001 	void            ModifyFrame( USHORT, const SfxItemSet& );
//STRIP001 	void            DeleteFrame( USHORT );
//STRIP001 	void 			SetFrameSpacing( long nValue );
//STRIP001 	void			ForceInit( BOOL bWithFrames = TRUE );

#if _SOLAR__PRIVATE
//STRIP001 	SfxFrameSetDescriptor*
//STRIP001 					GetDescriptor_Impl()
//STRIP001 					{ return pDescriptor; }
//STRIP001 	void			FrameFinishedLoading_Impl( SfxFrame *pFrame );
//STRIP001 	DECL_LINK(		SplitHdl_Impl, SfxFrameSetWindow_Impl* );
//STRIP001 	void			UpdateFrame_Impl( SfxURLFrame* );
#endif
};

}//end of namespace binfilter
#endif

